.\"	$NetBSD: cmdide.4,v 1.3 2003/12/14 01:00:20 thorpej Exp $
.\"
.\" Copyright (c) 2003 Manuel Bouyer.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd December 13, 2003
.Dt CMDIDE 4
.Os
.Sh NAME
.Nm cmdide
.Nd CMD Technology and Silicon Image IDE disk controllers driver
.Sh SYNOPSIS
.Cd "cmdide* at pci? dev ? function ? flags 0x0000"
.Cd "options PCIIDE_CMD064x_DISABLE"
.Cd "options PCIIDE_CMD0646U_ENABLEUDMA"
.Sh DESCRIPTION
The
.Nm
driver supports the CMD Technology PCI0640, PCI0643, PCI0646, PCI0648, PCI0649,
and Silicon Image 0680 IDE controllers, and provides the interface with the
hardware for the
.Xr ata 4
driver.
.Pp
The 0x0002 flag forces the
.Nm
driver to disable DMA on chipsets for which DMA would normally be
enabled.
This can be used as a debugging aid, or to work around
problems where the IDE controller is wired up to the system incorrectly.
.Sh SEE ALSO
.Xr ata 4 ,
.Xr atapi 4 ,
.Xr intro 4 ,
.Xr pci 4 ,
.Xr pciide 4 ,
.Xr wd 4 ,
.Xr wdc 4
.Sh BUGS
There's no way to reliably know if a PCI064x controller is enabled or not.
If the driver finds a PCI064x, it will assume it is enabled unless the
PCIIDE_CMD064x_DISABLE option is specified in the kernel config file.
This will be a problem only if the controller has been disabled in the BIOS
and another controller has been installed and uses the ISA legacy I/O ports
and interrupts.
.Pp
The PCI0646U controller is known to be buggy with Ultra-DMA transfers, so
Ultra-DMA is disabled by default for this controller.
To enable Ultra-DMA, use the PCIIDE_CMD0646U_ENABLEUDMA option.
Ultra-DMA can eventually be disabled on a per-drive basis with config
flags, see
.Xr wd 4 .
.Pp
The timings used for the PIO and DMA modes for controllers listed above
are for a PCI bus running at 30 or 33 MHz.
This driver may not work properly on overclocked systems.
